# ==== eD.py : enigma D (commercia) en python

import sys
import enigmaD
import string	

# ===================================
def is_maj(car):
	if string.ascii_uppercase.find(car) == -1: 
		return 0
	else:
		return 1
# ===================================
if len(sys.argv) < 8:
	print("syntaxe: enigmaD.py UKW LEFT MIDDLE RIGHT ETW RING GRUND [Debug]")
	sys.exit(1)
if len(sys.argv) > 8:
	DEBUG =1
else:
	DEBUG =0
UKW    = sys.argv[1]
LEFT   = sys.argv[2]
MIDDLE = sys.argv[3]
RIGHT  = sys.argv[4]
ETW    = sys.argv[5]
RING   = sys.argv[6]
GRUND  = sys.argv[7]

leTexte = sys.stdin.readlines()
c = enigmaD.Enigma(UKW,LEFT,MIDDLE,RIGHT, ETW, RING, GRUND, DEBUG)

crypto = ""	
for i in range(len(leTexte)):
	ch = leTexte[i]
	ch = ch.upper()
	for j in range(len(ch)):
		if not is_maj(ch[j]):
			continue
		car = c.encode(ch[j])
		crypto = crypto + car

print(crypto)
